# RGB vs. intensity processing

clear all, close all, clc
pkg load image
im = imread('Images/Flowers.tif');

# 1. Contrast stretching (= histogram equalization)
# RGB processing
##imr = histeq(im(:,:,1));            # R channel hist. equalization
##img = histeq(im(:,:,2));            # G channel hist. equalization
##imb = histeq(im(:,:,3));            # B channel hist. equalization
##imrgb = cat(3, imr, img, imb);      # merging 3 channels into R'G'B' image
##imshow(im), figure, imshow(imrgb)

# Intensity processing
##imn = rgb2ntsc(im);                 # conversion RGB --> YIQ
##imn(:,:,1) = histeq(imn(:,:,1));    # Y component hist. equalization
##imint = ntsc2rgb(imn);              # conversion Y'IQ --> R'G'B'
##imshow(im), figure, imshow(imint)


# 2. USM sharpening
# RGB processing
##h = fspecial('unsharp');
##imr = filter2(h, im(:,:,1));
##img = filter2(h, im(:,:,2));
##imb = filter2(h, im(:,:,3));
##imrgb = cat(3, imr, img, imb);
##imshow(im), figure, imshow(imrgb)

# Intensity processing
##imn = rgb2ntsc(im);
##h = fspecial('unsharp');
##imn(:,:,1) = filter2(h, imn(:,:,1));
##imint = ntsc2rgb(imn);
##imshow(im), figure, imshow(imint)


# 3. Edge detection (Canny filter)
# RGB processing
##imr = edge(im(:,:,1), 'canny');
##img = edge(im(:,:,2), 'canny');
##imb = edge(im(:,:,3), 'canny');
##imrgb = cat(3, imr, img, imb);
##imshow(im), figure, imshow(rgb2gray(double(imrgb))) # white edges

# Intensity processing
imn = rgb2ntsc(im);
imn(:,:,1) = edge(imn(:,:,1), 'canny');
imint = ntsc2rgb(imn);
imshow(im), figure, imshow(rgb2gray(imint))       # white edges
