# General procedure for performing DFT to an image
# and displaying the magnitude of the transform = 2D Fourier spectrum
# See also:
# http://matlabgeeks.com/tips-tutorials/how-to-do-a-2-d-fourier-transform-in-matlab/

clear all; close all; clc
im = imread('Images/Engine.tif');

F = fft2(double(im)); # convert to 'double', when im is of class 'uint8'
Fc = fftshift(F); # center the spectrum - DC shift
Fc_mag = log(1 + abs(Fc)); # display magnitude of DFT

# Reconstruct the image, i.e. perform inverse transform of F
im_rec = ifft2(F);

subplot(1,3,1), imshow(im), title('Original image')
subplot(1,3,2), imshow(Fc_mag, []), title('Fourier transform of the image')
subplot(1,3,3), imshow(im_rec, []), title('Reconstructed image')
