# Frequency filtering - removing periodic noise via notch filter
# https://stackoverflow.com/questions/34027840/removing-periodic-noise-from-an-image-using-the-fourier-transform

clear all; close all; clc
im = imread('Images/Face_pnoise.png');

spec_orig = fft2(double(im)); # perform DFT
spec_img = fftshift(spec_orig); # DC shift
spec_img([12:22 37:47 96:106 216:226 274:284 298:308],115:125) = 0 # specify notch filter locations
ptnfx = real(ifft2(ifftshift(spec_img))); # perform inverse DFT (after DC reshift)

imshow(im)
figure, imshow(log(1 + abs(fftshift(spec_orig))), []) # display FT image
figure, imshow(log(1 + abs(spec_img)), [])
figure, imshow(ptnfx,[])
