% Local operations - Edge detection operators
% Function 'edge' generates a BW image (in contrast to 'imfilter' function)

clear all; close all; clc
pkg load image;

im = imread('Images/Engine.tif');

im_s = edge(im, 'sobel');
im_p = edge(im, 'prewitt');
im_r = edge(im, 'roberts');
im_c = edge(im, 'canny');
im_l = edge(im, 'log');

subplot(2,3,1), imshow(im), title('Original image'),
subplot(2,3,2), imshow(im_s), title('Sobel'),
subplot(2,3,3), imshow(im_p), title('Prewitt'),
subplot(2,3,4), imshow(im_r), title('Roberts'),
subplot(2,3,5), imshow(im_c), title('Canny'),
subplot(2,3,6), imshow(im_l), title('Laplacian of Gaussian')
