# Local operations - Linear filtering --> sharpening by USM filter

clear all; close all; clc
pkg load image;

im = imread('Images/Cameraman.tif');
h = fspecial('unsharp', 0.2) # Unsharp mask operator
im_usm = imfilter(im, h);

col = size(im, 2); # image width
raw_no = 100; # raw no. of the profile line

imshow(im, []), title('Original image')
hold on, line([1, col], [raw_no, raw_no], 'Color', 'r') # draw profile line
figure, imshow(im_usm, []), title('Sharpened by USM')
hold on, line([1, col], [raw_no, raw_no], 'Color', 'r') # draw profile line
figure, plot((1:col), im(raw_no, 1:end)) # draw profile
axis([0 col 0 col]), title(['Profile at the row No. ', num2str(raw_no)])
figure, plot((1:col), im_usm(raw_no, 1:end)) # draw profile
axis([0 col 0 col]), title(['Profile at the row No. ', num2str(raw_no)])


##help imfilter
##help fspecial
