# Local operations - Linear filtering --> smoothing

clear all; close all; clc
pkg load image;

im = imread('Images/Blobs_gnoise.tif'); # experiment with Blobs_gnoise image!
col = size(im, 2); # image width
raw_no = 50; # raw no. of the profile line

### Mean (box) filter
##h = fspecial('average', 13);

# Gaussian filter
h_size = 9;
h_sigma = 2;
h = fspecial('gaussian', h_size, h_sigma);

im_filt = imfilter(im, h, 'conv', 'symmetric'); # reflect across image borders

subplot(2, 3, 1), imshow(im), title('Original image')
hold on, line([1, col], [raw_no, raw_no], 'Color', 'r') # draw profile line
subplot(2, 3, 2), imshow(im_filt), title('Filtered image')
hold on, line([1, col], [raw_no, raw_no], 'Color', 'r') # draw profile line
subplot(2, 3, 3), imshow(h, [], 'InitialMagnification', 'fit'), title('Filter matrix')
subplot(2, 3, 4), plot((1:col), im(raw_no, 1:end)) # draw profile
axis([0 col 0 col]), title(['Profile at the row No. ', num2str(raw_no)])
subplot(2, 3, 5), plot((1:col), im_filt(raw_no, 1:end)) # draw profile
axis([0 col 0 col]), title(['Profile at the row No. ', num2str(raw_no)])

##figure, imhist(im)
##figure, imhist(im_filt) # Blobs_gnoise image can now be thresholded!


##help imfilter
##help fspecial
