# Morphological operations - Connected components labelling

clear all; close all; clc
pkg load image

im = imread('Images/Text.png');
im = im2bw(im);

se = [0 0 1;0 1 0;1 0 0]; # same as: se = strel('line', 3, 45)
cc = imclose(im, se); # merge individual letters into larger objects (conn. components)
cc2 = bwareaopen(cc, 300); # remove objects < 300

[L, num] = bwlabel(cc2); # label objects in cc image
RGB = label2rgb(L); # display conn. components in different colours

imshow(im), figure, imshow(cc), figure, imshow(cc2), figure, imshow(RGB)


##help bwconncomp
