# Point operations - Reducing Gaussian noise by averaging

clear all, close all, clc
pkg load image;

im = imread('Images/Engine.tif');

s = size(im);
numPics = 10;   # Experiment with values 10, 100 and 1000!
im_ga = zeros(s(1), s(2), numPics);

for i = 1:numPics
  im_ga(:, :, i) = imnoise(im, 'gaussian');
  subplot(2, 5, i), imshow(im_ga(:, :, i), []), title(['Image No. ' int2str(i)])
end

im_ga_av = mean(im_ga, 3);
figure, imshow(im), figure, imshow(im_ga_av, [])


##imnoise
