# Point operations - Histogram

clear all; close all; clc
pkg load image;

im = imread('Images/Venice_lc.tif'); # load a low-contrast image
imshow(im), figure
##imhist(im), figure, plot(cumsum(imhist(im))) # display ordinary and cumulative
##                                             # image histogram
##[counts, binloc] = imhist(im); # compute histogram counts and bin locations

im_adj = imadjust(im); # histogram (contrast) stretching
im_eq = histeq(im); # histogram equalization

subplot(3, 3, 1), imshow(im), title('Original image')
subplot(3, 3, 2), imhist(im), title('Original image histogram')
subplot(3, 3, 3), plot(cumsum(imhist(im))), xlim([0 255]) # cumulative hist.
title('Original image cumulative histogram')

subplot(3, 3, 4), imshow(im_adj), title('Contrast-stretched image')
subplot(3, 3, 5), imhist(im_adj), title('Contrast-stretched image histogram')
subplot(3, 3, 6), plot(cumsum(imhist(im_adj))), xlim([0 255])
title('Contrast-stretched image cumulative histogram')

subplot(3, 3, 7), imshow(im_eq), title('Histogram-equalized image')
subplot(3, 3, 8), imhist(im_eq), title('Histogram-equalized image histogram')
subplot(3, 3, 9), plot(cumsum(imhist(im_eq))), xlim([0 255])
title('Histogram-equalized image cumulative histogram')


##help imadjust
##help histeq
