# Point operations - Thresholding

clear all; close all; clc
pkg load image;

im = imread('Images/Oxford.tif'); # load a grayscale image (test also Blobs.tif)

# Global thresholding (Otsu's method; threshold = level)
level = graythresh(im); # Otsu's threshold
im_bw = im2bw(im, level); # convert image to binary (test different level values)

subplot(1, 2, 1), imshow(im), title('Original image')
subplot(1, 2, 2), imshow(im_bw), title('Binary image')

### Adaptive thresholding (works only with MATLAB :( )
##im = imread('Images/Oxford.tif');
##im_bw = imbinarize(im, 'adaptive', 'ForegroundPolarity', 'dark', 'Sensitivity', 0.4);
##im_bw2 = adaptthresh(im);
##subplot(1, 3, 1), imshow(im), title('Original image')
##subplot(1, 3, 2), imshow(im_bw), title('Binary image')
##subplot(1, 3, 3), imshow(im_bw2), title('Binary image2')


##help graythresh
